function love.load()
	love.window.setTitle('Pong')
	screen_w = 1366
	screen_h =  768
	canvas_w = 1200
	canvas_h =  600
	love.window.setMode(screen_w, screen_h, { fullscreen = true })
	canvas_s = love.graphics.newCanvas(canvas_w, canvas_h)
	love.mouse.setVisible(false) -- Hides The Mouse Cursor
	octopusback = love.graphics.newImage('assets/octopusback.png')
	squaredi_40 = love.graphics.newFont('assets/squaredi.ttf', 40)
	squaredi_80 = love.graphics.newFont('assets/squaredi.ttf', 80)
	squaredih80 = squaredi_80:getHeight()
	sound_collision = love.audio.newSource('assets/collision.wav')
	fps = love.timer.getFPS()
	aku = 'up'
	akd = 'down'
	dfl = 'left'
	dfr = 'right'
	player1 = {}
		player1.w = 10
		player1.h = 100
		player1.x = canvas_w/2 - player1.w/2
		player1.y = canvas_h/2 - player1.h/2
		player1.speed = 600
		player1.beats = 0
		player1.score = 0
	player2 = {}
		player2.w = 10
		player2.h = 100
		player2.x = canvas_w/2 - player2.w/2
		player2.y = canvas_h/2 - player2.h/2
		player2.speed = 600
		player2.beats = 0
		player2.score = 0
	ball = {}
		ball.w = 10
		ball.h = 10
		ball.x = canvas_w/2 - ball.w/2
		ball.y = canvas_h/2 - ball.h/2
		ball.xspeed = 200
		ball.yspeed = 200
end

function love.update(dt)
	-- Player 1 - Keyboard
	if love.keyboard.isDown('w') then player1.y = player1.y - player1.speed*dt
elseif love.keyboard.isDown('s') then player1.y = player1.y + player1.speed*dt
elseif love.keyboard.isDown('e') then love.event.quit()
	end
	-- Player 2 - Keyboard
	if love.keyboard.isDown(aku) then player2.y = player2.y - player2.speed*dt
elseif love.keyboard.isDown(akd) then player2.y = player2.y + player2.speed*dt
	end
	-- Player 1 - Collision With Screen
	if player1.y < 0 then player1.y = 0
elseif player1.y > canvas_h - player1.h then player1.y = canvas_h - player1.h
	end
	-- Player 2 - Collision With Screen
	if player2.y < 0 then player2.y = 0
elseif player2.y > canvas_h - player2.h then player2.y = canvas_h - player2.h
	end
	-- Ball
	ball.x = ball.x + ball.xspeed*dt
	ball.y = ball.y + ball.yspeed*dt
	-- Ball - Collision
	if ball.y < 0 then sound_collision:play(); ball.yspeed = math.abs(ball.yspeed)
elseif ball.y > canvas_h - ball.h then sound_collision:play(); ball.yspeed = -math.abs(ball.yspeed)
	end
	-- Ball - Collision With Player 1 / Player 2
	if ball.x < 20   and ball.y + ball.h > player1.y and ball.y < player1.y + player1.h then sound_collision:play(); ball.xspeed =  math.abs(ball.xspeed) + 100
elseif ball.x > 1170 and ball.y + ball.h > player2.y and ball.y < player2.y + player2.h then sound_collision:play(); ball.xspeed = -math.abs(ball.xspeed) - 100
	end
	-- Beats
	if ball.x < 20   and ball.y + ball.h > player1.y and ball.y < player1.y + player1.h then player1.beats = player1.beats + 1
elseif ball.x > 1170 and ball.y + ball.h > player2.y and ball.y < player2.y + player2.h then player2.beats = player2.beats + 1
	end
	-- Score
	if ball.x > 1200 then player1.score = player1.score + 1
elseif ball.x <  -10 then player2.score = player2.score + 1
	end
	-- Ball - Reset
	if ball.x <  -10 then ball.x = canvas_w/2 - ball.w/2; ball.y = canvas_h/2 - ball.h/2; ball.xspeed = -200
elseif ball.x > 1200 then ball.x = canvas_w/2 - ball.w/2; ball.y = canvas_h/2 - ball.h/2; ball.xspeed =  200
	end
end

function love.draw()
	-- Set Canvas
	love.graphics.setCanvas(canvas_s)
	-- Draw Octopus
	love.graphics.draw(octopusback, 0, 0)
	-- Set Color - Blue - 100
	love.graphics.setColor(  0,   0, 255, 100)
		-- Horizontal Lines - Blue
		love.graphics.rectangle('fill',    0,  99, 600,   1)
		love.graphics.rectangle('fill',    0, 199, 600,   1)
		love.graphics.rectangle('fill',    0, 299, 600,   2)
		love.graphics.rectangle('fill',    0, 400, 600,   1)
		love.graphics.rectangle('fill',    0, 500, 600,   1)
		-- Vertical Lines - Blue
		love.graphics.rectangle('fill',   99,   0,   1, 600)
		love.graphics.rectangle('fill',  199,   0,   1, 600)
		love.graphics.rectangle('fill',  299,   0,   1, 600)
		love.graphics.rectangle('fill',  399,   0,   1, 600)
		love.graphics.rectangle('fill',  499,   0,   1, 600)
			-- Set Color - Blue - 255
			love.graphics.setColor(  0,   0, 255, 255)
				-- Draw Player 1
				love.graphics.rectangle('fill', player1.x - 585, player1.y, player1.w, player1.h)
	-- Set Color - Green - 100
	love.graphics.setColor(  0, 255,   0, 100)
		-- Horizontal Lines - Green
		love.graphics.rectangle('fill',  600,  99, 600,   1)
		love.graphics.rectangle('fill',  600, 199, 600,   1)
		love.graphics.rectangle('fill',  600, 299, 600,   2)
		love.graphics.rectangle('fill',  600, 400, 600,   1)
		love.graphics.rectangle('fill',  600, 500, 600,   1)
		-- Vertical Lines - Green
		love.graphics.rectangle('fill',  700,   0,   1, 600)
		love.graphics.rectangle('fill',  800,   0,   1, 600)
		love.graphics.rectangle('fill',  900,   0,   1, 600)
		love.graphics.rectangle('fill', 1000,   0,   1, 600)
		love.graphics.rectangle('fill', 1100,   0,   1, 600)
			-- Set Color - Green - 255
			love.graphics.setColor(  0, 255,   0, 255)
				-- Draw Player 2
				love.graphics.rectangle('fill', player2.x + 585, player2.y, player2.w, player2.h)
	-- Set Color - White
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.rectangle('fill', 599, 0, 2, 600)
	love.graphics.rectangle('fill', ball.x, ball.y, ball.w, ball.h)
		-- Squaredi 40
		love.graphics.setFont(squaredi_40)
			-- FPS Counter
			love.graphics.print('fps: ' .. tostring(love.timer.getFPS( )), 30, 18)
		-- Squaredi 80
		love.graphics.setFont(squaredi_80)
			-- Draw Beats
			love.graphics.printf(player1.beats, canvas_w/2 - 25 + 0, canvas_h - squaredih80 - 10, 0, dfr)
			love.graphics.printf(player2.beats, canvas_w/2 + 25 + 8, canvas_h - squaredih80 - 10, 0, dfl)
			-- Draw Score
			love.graphics.printf(player1.score, canvas_w/2 - 25 + 0, 10, 0, dfr)
			love.graphics.printf(player2.score, canvas_w/2 + 25 + 8, 10, 0, dfl)
	-- End Canvas
	love.graphics.setCanvas()
	-- Scaling - Maintain Aspect Ratio
	scale = math.min(screen_w/canvas_w, screen_h/canvas_h)
	love.graphics.push()
	love.graphics.translate(math.floor((screen_w - canvas_w * scale)/2), math.floor((screen_h - canvas_h * scale)/2))
	love.graphics.scale(scale, scale)
	love.graphics.draw(canvas_s)
	love.graphics.pop()
end